package org.processmining.resourcerecommendation.algorithms;

import lpsolve.LpSolveException;

import org.processmining.framework.plugin.PluginContext;
import org.processmining.resourcerecommendation.models.ResourceKnowledge;
import org.processmining.resourcerecommendation.models.ResourceRecommendation;
import org.processmining.resourcerecommendation.parameters.RecommendResourcesParameters;

public class RecommendResourcesAlgorithm {
	
	public ResourceRecommendation apply(PluginContext context, ResourceKnowledge knowledge, RecommendResourcesParameters parameters) throws LpSolveException {
		return apply(knowledge, parameters);
	}

	public ResourceRecommendation apply(ResourceKnowledge knowledge, RecommendResourcesParameters parameters) throws LpSolveException {
		if (parameters.getAlgorithm().equals(RecommendResourcesParameters.ALGORITHM.ALLOCATION)){
			AllocationAlgorithm algorithm = new AllocationAlgorithm();
			return algorithm.apply(knowledge, parameters);
		}
		else if (parameters.getAlgorithm().equals(RecommendResourcesParameters.ALGORITHM.RECOMENDATION)){
			RecommendationAlgorithm algorithm = new RecommendationAlgorithm();
			return  algorithm.apply(knowledge, parameters);
		}
		else{
			return null;
		}
	}
	
	
}
