package org.processmining.resourcerecommendation.algorithms.bpa;

import java.util.ArrayList;

public class Database {
  public List [] lists;
  public int m;
  public int n;
  public DataItemPositions  [] dataPositions;

  public Database(int in_m, int in_n)
  {
    m = in_m;
    n = in_n;
    lists = new List[m];
    int i, j;
    for (i=0; i<m; ++i) {
      lists[i] = new List();
      lists[i].elements = new ArrayList<ListElement>(n);
      for (j=0; j<n; ++j)
      {
        lists[i].elements.add(new ListElement());
      }
    }

    dataPositions = new DataItemPositions [n];
    for (j=0; j<n; ++j) {
      dataPositions[j] = new DataItemPositions();
      dataPositions[j].dataID = j;
      dataPositions[j].positionsInLists = new int [m];
    }
  }

 
 public void sortLists() {
	 for (int i=0; i<m; ++i) {
	      lists[i].sortElements(n);
	      for (int j=0; j<n; ++j)
	      {
	        int dataID = lists[i].elements.get(j).dataID;
	        dataPositions[dataID].positionsInLists[i] = j;
	      }
	    }
 }
 

 public void printDatabase() {
   int i, j;
   double temp;

   int dataID;
   for (j=0; j<n; ++j) {
     System.out.print((j+1) + "  -> " );
     for (i=0; i<m; ++i){
       temp = Math.round ((lists[i].elements.get(j).score) * 1000);
       temp = temp / 1000;
       dataID = lists[i].elements.get(j).dataID;
       System.out.print (dataID + " : " + temp + " ,   ");
     }

     System.out.println();
   }
 }


 public void printPositions() {
   int i, j;
   double temp;
   for (j=0; j<n; ++j) {
     System.out.print (j + " : ");
     for (i=0; i<m; ++i){
       temp = Math.round ((dataPositions[j].positionsInLists[i]) * 1000);
       temp = temp / 1000;
       temp = temp + 1;
       System.out.print(temp + " , ");
     }
     System.out.println();
   }
 }

}
