package org.processmining.resourcerecommendation.algorithms.bpa;



public class UseBPAExample {

	public static void main(String[] args) {
		
		// Size information
		int numColumns = 3;
		int numRows = 4;
		
		//Create the BPA Database
		Database db = new Database(numColumns, numRows);
		
		//Fill the Database with example numbers
			
		// Important: data IDs should be integer values in [0 ...numRows - 1].
			//Row 0
		db.lists[0].elements.get(0).dataID = 0;
		db.lists[0].elements.get(0).score = 20;
		db.lists[1].elements.get(0).dataID = 0;
		db.lists[1].elements.get(0).score = 20;
		db.lists[2].elements.get(0).dataID = 0;
		db.lists[2].elements.get(0).score = 20;
		
			//Row 1
		db.lists[0].elements.get(1).dataID = 1;
		db.lists[0].elements.get(1).score = 5;
		db.lists[1].elements.get(1).dataID = 1;
		db.lists[1].elements.get(1).score = 8;
		db.lists[2].elements.get(1).dataID = 1;
		db.lists[2].elements.get(1).score = 8;
		
			//Row 2
		db.lists[0].elements.get(2).dataID = 2;
		db.lists[0].elements.get(2).score = 1;
		db.lists[1].elements.get(2).dataID = 2;
		db.lists[1].elements.get(2).score = 2;
		db.lists[2].elements.get(2).dataID = 2;
		db.lists[2].elements.get(2).score = 3;
		
			//Row 3
		db.lists[0].elements.get(3).dataID = 3;
		db.lists[0].elements.get(3).score = 5.0;
		db.lists[1].elements.get(3).dataID = 3;
		db.lists[1].elements.get(3).score = 5.0;
		db.lists[2].elements.get(3).dataID = 3;
		db.lists[2].elements.get(3).score = 5.0;
		
		//IMPORTANT Sort the lists before start		
		db.sortLists();
		
		//Print the database before start
		db.printDatabase();
		
		//Create the object to call the ranking algorithms
		TopkAlgorithms algorithms = new TopkAlgorithms(db);
		
		int k = 4; // Number of recommendations
		
		MyInteger stopPosition = new MyInteger();
		MyInteger sortedAccess = new MyInteger();
		MyInteger randomAccess = new MyInteger();
		AnswerElement [] answers = new AnswerElement[k];
		
		//Call TA
		System.out.println();
    	System.out.print("Results using TA:");
		algorithms.TA(k, stopPosition, sortedAccess, randomAccess, answers);
		algorithms.printAnswers(answers, k);
		System.out.println();
		System.out.println("stop position: " + stopPosition.getValue());
		
		
		// Call BPA
		System.out.println();
    	System.out.print("Results using BPA:");
		algorithms.BPA(k, stopPosition, sortedAccess, randomAccess, answers);
    	algorithms.printAnswers(answers, k);
    	System.out.println();
		System.out.println("stop position: " + stopPosition.getValue());
		
//		//Call BPA2
    	System.out.println();
    	System.out.print("Results using BPA2:");
    	
		
		MyInteger directAccess = new MyInteger();
		algorithms.BPA2(k, stopPosition, directAccess, randomAccess, answers);
		algorithms.printAnswers(answers, k);
		System.out.println();
		System.out.println("stop position: " + stopPosition.getValue());

	}

}
