package org.processmining.resourcerecommendation.connections;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.resourcerecommendation.models.ResourceKnowledge;
import org.processmining.resourcerecommendation.parameters.GenerateResourceKnowledgeParameters;

public class GenerateResourceKnowledgeConnection extends AbstractConnection {

	public final static String LOG = "Log";

	public final static String KNOWLEDGE = "Resource Knowledge";

	private GenerateResourceKnowledgeParameters parameters;


	public GenerateResourceKnowledgeConnection(XLog log, ResourceKnowledge knowledge, GenerateResourceKnowledgeParameters parameters) {
		super("Generate Resource Knowledge Connection");
		put(LOG, log);
		put(KNOWLEDGE, knowledge);
		this.parameters = new GenerateResourceKnowledgeParameters(parameters);
	}

	public GenerateResourceKnowledgeParameters getParameters() {
		return parameters;
	}
}
