package org.processmining.resourcerecommendation.connections;

import org.processmining.framework.connections.impl.AbstractConnection;
import org.processmining.resourcerecommendation.models.ResourceKnowledge;
import org.processmining.resourcerecommendation.models.ResourceRecommendation;
import org.processmining.resourcerecommendation.parameters.RecommendResourcesParameters;

public class RecommendResourcesConnection extends AbstractConnection {

	public final static String KNOWLEDGE = "Resource Knowledge";
	
	public final static String RECOMMENDATION = "Recommendation";

	private RecommendResourcesParameters parameters;


	public RecommendResourcesConnection(ResourceKnowledge knowledge, ResourceRecommendation recommendation, 
			RecommendResourcesParameters parameters) {
		super("Recommend Resources Connection");
		put(KNOWLEDGE, knowledge);
		put(RECOMMENDATION, recommendation);
		this.parameters = new RecommendResourcesParameters(parameters);
	}

	public RecommendResourcesParameters getParameters() {
		return parameters;
	}
}
