package org.processmining.resourcerecommendation.models;

import java.util.ArrayList;
import java.util.List;

public interface ResourceKnowledge {
	
	public void addResource(Resource resource);
	
	public List<Resource> getResources();
	
	public void addUnit(Unit unit);
	
	public List<Unit> getUnits();
	
	public void addFactor(Factor factor);
	
	public void addTypology(Typology typology);
	
	public void addCharacterization(Characterization characterization);
	
	public List<Characterization> getCharacterizations();
	
	public void addExpertise(Expertise expertise);
	
	public List<Expertise> getExpertises();
	
	public List<Dimension> getDimensions();
	
	public void addFrequency(String characterizationId, String resourceId);
	
	public double getMetric(String dimensionId, String characterizationId, String resourceId);
	
	public ArrayList<Double> getMetric(String dimensionId, String[] characterizationIds, String[] resourceIds);
	
	public void addQuality(String characterizationId, String resourceId, long quality);
	
	public void addPerformance(String characterizationId, String resourceId, Double duration);
	
	public void addCost(String characterizationId, String resourceId, Double cost);
	
	public void addRequiredExpertise(String characterizationId, String expertiseId, Long value);
	
	public void addResourceExpertise(String resourceId, String expertiseId, Long value);
	
	public void addWorkload(String resourceId, long max, long current);

}
