// By Mike
package org.processmining.resourcerecommendation.models.impl;

import org.processmining.resourcerecommendation.models.CostResource;

public class CostResourceImpl implements CostResource {
	
	private String resourceId;
	private long total;
	private double totalDuration;
	private double minDuration;
	private double maxDuration;
	
	protected CostResourceImpl(String resourceId){
		this.resourceId = resourceId;
		this.total = 0;
		this.totalDuration = 0;
		this.minDuration = 0;
		this.maxDuration = 0;
	}

	public void addCost(double duration) {
		total = total + 1;
		totalDuration += duration;
		
		if (total == 1){
			minDuration = duration;
			maxDuration = duration;
		} else{
			if (duration < minDuration) minDuration = duration;
			if (duration > maxDuration) maxDuration = duration;
		}
	}

	public String getResourceId() {
		return resourceId;
	}

	public long getTotal() {
		return total;
	}

	public Double getAverage() {
		if (total>0) return (totalDuration)/total;
		else return 0.0;
	}
	
	public Double getMin() {
		return minDuration;
	}

	public Double getMax() {
		return maxDuration;
	}
}
