package org.processmining.resourcerecommendation.models.impl;

import java.util.LinkedHashMap;
import java.util.Map;

import org.processmining.resourcerecommendation.models.FrequencyCharacterization;
import org.processmining.resourcerecommendation.models.FrequencyResource;

public class FrequencyCharacterizationImpl implements FrequencyCharacterization {
	
	private String characterizationId;
	private Map<String, FrequencyResource> resources;
	
	protected FrequencyCharacterizationImpl(String characterizationId){
		this.characterizationId = characterizationId;
		this.resources = new LinkedHashMap<String, FrequencyResource>();
	}
	
	public void addFrequency(String resourceId){
		FrequencyResource resource = resources.get(resourceId);
		if (resource == null){
			resource = ResourceProcessFactory.createFrequencyResource(resourceId);
			resources.put(resourceId, resource);
		}
		resource.addFrequency();
	}
	
	public long getTotal(String resourceId) {
		long result = resources.containsKey(resourceId) ? 
				resources.get(resourceId).getTotal() : 0;
		return result;	
	}
	
	public long getTotal(){
		long result = 0;
		for (FrequencyResource resource: resources.values()){
			result += resource.getTotal();
		}
		return result;
	}

	public String getCharacterizationId() {
		return characterizationId;
	}

	
	

}
