// By Mike
package org.processmining.resourcerecommendation.models.impl;

import org.processmining.resourcerecommendation.models.QualityResource;

public class QualityResourceImpl implements QualityResource {
	
	private String resourceId;
	private long total;
	private long totalQuality;
	private long minQuality;
	private long maxQuality;
	
	protected QualityResourceImpl(String resourceId){
		this.resourceId = resourceId;
		this.total = 0;
		this.totalQuality = 0;
		this.minQuality = 0;
		this.maxQuality = 0;
	}

	public void addQuality(long quality) {
		total = total + 1;
		totalQuality += quality;
		
		if (total == 1){
			minQuality = quality;
			maxQuality = quality;
		} else{
			if (quality < minQuality) minQuality = quality;
			if (quality > maxQuality) maxQuality = quality;
		}
	}

	public String getResourceId() {
		return resourceId;
	}

	public long getTotal() {
		return total;
	}

	public Double getAverage() {
		if (total>0) return ((double) totalQuality)/total;
		else return 0.0;
	}
	
	public long getMin() {
		return minQuality;
	}

	public long getMax() {
		return maxQuality;
	}
}
