// Copyright (C) 2014 by Jorge Munoz-Gama. All rights reserved. 
// Released under the terms of the Lesser GNU General Public License (L-GPL) version 2 or later.

package org.processmining.resourcerecommendation.models.impl;

import java.util.LinkedHashMap;
import java.util.Map;

import org.processmining.resourcerecommendation.models.RecommendationElement;

public class RecommendationElementImpl implements RecommendationElement {
	
	private String resourceId;
	private String resourceDescription;
	private double overallScore;
	private Map<String, Double> scores;
	
	protected RecommendationElementImpl(String resourceId, String resourceDescription){
		this.resourceId = resourceId;
		this.resourceDescription = resourceDescription;
		this.overallScore = -1.0;
		this.scores = new LinkedHashMap<String, Double>();
	}
	
	public String getResourceId() {
		return resourceId;
	}

	public String getResourceDescription() {
		return resourceDescription;
	}

	public void setOverallScore(double overallScore){
		this.overallScore = overallScore;
	}
	
	public double getOverallScore(){
		return overallScore;
	}
	
	public void setScore(String dimensionId, double score){
		this.scores.put(dimensionId, score);
	}
	
	public double getScore(String dimensionId){
		return this.scores.get(dimensionId);
	}

	public Map<String, Double> getScores() {
		return new LinkedHashMap<String, Double>(scores);
	}
	
	

}
