// Copyright (C) 2014 by Jorge Munoz-Gama. All rights reserved. 
// Released under the terms of the Lesser GNU General Public License (L-GPL) version 2 or later.

package org.processmining.resourcerecommendation.models.impl;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.processmining.resourcerecommendation.models.RecommendationElement;
import org.processmining.resourcerecommendation.models.Request;
import org.processmining.resourcerecommendation.models.ResourceRecommendation;

public class ResourceRecommendationImpl implements ResourceRecommendation {
	
	private Map<Request, List<RecommendationElement>> rankings;
	
	protected ResourceRecommendationImpl(){
		this.rankings = new LinkedHashMap<Request, List<RecommendationElement>>();
	}

	public Map<Request, List<RecommendationElement>> getRankings() {
		return new LinkedHashMap<Request, List<RecommendationElement>>(rankings);
	}

	public void setRanking(Request request, List<RecommendationElement> ranking) {
		this.rankings.put(request, ranking);
	}

	
	
	
}
